SystemOrganization addCategory: #'A3-Model-Tests'!
SystemOrganization addCategory: #'A3-Model'!

Object subclass: #A3TodoList
	instanceVariableNames: 'todo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A3-Model'!

!A3TodoList class methodsFor: 'as yet unclassified' stamp: 'DiegoSanchez 1/3/2013 15:25'!
asString
	| classSelectors todoSelectors |
	classSelectors := self class organization allMethodSelectors.
	todoSelectors := classSelectors select: [ :selector | selector includesSubString: 'todo'].
	^ '"',(self transform: todoSelectors), '"'.
	! !

!A3TodoList class methodsFor: 'as yet unclassified' stamp: 'DiegoSanchez 1/3/2013 15:25'!
todoDetectingIfHomeworkIsSolved
	^'Before the student is able to post homework the API should check if homework was solved properly'! !

!A3TodoList class methodsFor: 'private' stamp: 'DiegoSanchez 1/3/2013 15:24'!
transform: aListOfTodoSelectors
	aListOfTodoSelectors isEmpty ifTrue: [
		^'Nothing to be done'.
	].

	^aListOfTodoSelectors
		inject: '' into: [ :result :todo | 
			result, String cr, '- ', (self perform: todo), String cr.
		].! !

Object subclass: #A3Tp
	instanceVariableNames: 'code student'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A3-Model'!

!A3Tp commentStamp: 'DiegoSanchez 12/30/2012 10:04' prior: 0!
An A3Tp is a SmallTalk TP for AlgoIII Fiuba.
!

!A3Tp class methodsFor: 'as yet unclassified' stamp: 'DS 1/2/2013 16:35'!
download: aStudent
	| tp  |
	tp := self new.
	tp student: aStudent.
	^tp.! !

!A3Tp class methodsFor: 'as yet unclassified' stamp: 'DiegoSanchez 1/2/2013 17:03'!
resource
	^'http://localhost:81/current_homework/7507-1C2012-TP0-Enunciado1.txt'.! !

!A3Tp methodsFor: 'as yet unclassified' stamp: 'DiegoSanchez 1/3/2013 09:41'!
code
	code isNil ifTrue: [
		code := HTTPClient httpGet: A3Tp resource.
	].
	^code contents asString.
	! !

!A3Tp methodsFor: 'as yet unclassified' stamp: 'DS 1/2/2013 16:36'!
student: aStudent
	student := aStudent.! !

!A3Tp methodsFor: 'as yet unclassified' stamp: 'DS 1/2/2013 14:10'!
title
	^'TP 0'.! !

TestCase subclass: #TestA3Tp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A3-Model-Tests'!

!TestA3Tp methodsFor: 'as yet unclassified' stamp: 'DiegoSanchez 1/2/2013 17:26'!
testGettingTp0
	| tp |
	tp := A3Tp download: nil "student".
	self assert: (tp code asString includesSubString: '').! !
